/*  $Id: xml_tokenizer_generic.h,v 1.4 2003/09/08 15:08:51 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_xml_tokenizer_generic
#define header_xml_tokenizer_generic

#include "API/Core/IOData/inputsource.h"

class CL_XMLTokenizer_Generic
{
//! Construction:
public:
	CL_XMLTokenizer_Generic() : input(0), delete_input(false), pos(0), size(0), ref_count(0) { return; }

	~CL_XMLTokenizer_Generic() { if (delete_input) delete input; }

//! Attributes:
public:
	CL_InputSource *input;
	
	bool delete_input;

	std::string::size_type pos, size;

	std::string data;

//! Operations:
public:
	void add_ref() { ref_count++; }

	void release_ref() { if (--ref_count == 0) delete this; }

//! Implementation:
private:
	int ref_count;
};

#endif
