/*  $Id: display_target.h,v 1.7 2003/09/08 15:22:54 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_display_target
#define header_display_target

#include "API/Display/surface.h"

class CL_DisplayWindow_Generic;
class CL_Surface_Target;

class CL_DisplayTarget
{
//! Construction:
public:
	CL_DisplayTarget();

	virtual ~CL_DisplayTarget();

//! Attributes:
public:
	static CL_DisplayTarget *current;

//! Operations:
public:
	virtual CL_DisplayWindow_Generic *create_window()=0;

	virtual CL_Surface_Target *create_surface(
		CL_PixelBuffer *provider,
		bool delete_provider,
		CL_Surface::Hint hint)=0;

	virtual bool enable_packer()=0;

//! Implementation:
private:
};

#endif
